"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var equal = require('equals');
var SelectAccessor = (function () {
    function SelectAccessor() {
        this._value = [];
    }
    Object.defineProperty(SelectAccessor.prototype, "value", {
        get: function () {
            return this._value;
        },
        set: function (value) {
            this._value = value;
            this._onChangeCallback(this._value);
        },
        enumerable: true,
        configurable: true
    });
    ;
    SelectAccessor.prototype.onTouched = function (value) {
        this._onTouchedCallback(value);
    };
    SelectAccessor.prototype.writeValue = function (value) {
        this._value = value || [];
    };
    SelectAccessor.prototype.findIndexValue = function (value) {
        var identifyBy = this.identifyBy;
        if (identifyBy) {
            if (!value || !value.hasOwnProperty(identifyBy)) {
                return;
            }
            value = this.options.filter(function (item) { return item[identifyBy] === value[identifyBy]; })[0];
        }
        return this.options.findIndex(function (item) { return equal(item, value); });
    };
    SelectAccessor.prototype.identify = function (value) {
        var identifyBy = this.identifyBy;
        return identifyBy && value ? value[identifyBy] : undefined;
    };
    SelectAccessor.prototype.registerOnChange = function (fn) {
        this._onChangeCallback = fn;
    };
    SelectAccessor.prototype.registerOnTouched = function (fn) {
        this._onTouchedCallback = fn;
    };
    return SelectAccessor;
}());
exports.SelectAccessor = SelectAccessor;
//# sourceMappingURL=accessor.js.map