"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var selectable_1 = require("./decorators/selectable");
var forms_1 = require("@angular/forms");
var ng2_material_dropdown_1 = require("ng2-material-dropdown");
var accessor_1 = require("./accessor");
var equal = require('equals');
var CUSTOM_SELECT_VALUE_ACCESSOR = {
    provide: forms_1.NG_VALUE_ACCESSOR,
    useExisting: core_1.forwardRef(function () { return Ng2Select; }),
    multi: true
};
var Ng2Select = (function (_super) {
    __extends(Ng2Select, _super);
    function Ng2Select() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.placeholder = '';
        _this.options = [];
        _this.displayBy = '';
        _this.identifyBy = '';
        _this.selectedDisplayBy = '';
        _this.multiple = false;
        _this.onChange = new core_1.EventEmitter();
        return _this;
    }
    Ng2Select.prototype.getSelectedValue = function () {
        var _this = this;
        if (this.multiple && this.value.length === 1) {
            return this.selectedDisplayValue(this.value[0]);
        }
        else {
            var index = this.options.findIndex(function (item) { return equal(_this.value, item); });
            return index >= 0 ? this.selectedDisplayValue(this.options[index]) : undefined;
        }
    };
    Ng2Select.prototype.selectedDisplayValue = function (item) {
        return this.selectedDisplayBy ? item[this.selectedDisplayBy] : this.displayValue(item);
    };
    Ng2Select.prototype.displayValue = function (item) {
        return this.displayBy ? item[this.displayBy] : item;
    };
    Object.defineProperty(Ng2Select.prototype, "placeholderDisplay", {
        get: function () {
            if (this.multiple && this.value.length > 1) {
                return this.value.length + " items selected";
            }
            else {
                return this.getSelectedValue() || this.placeholder;
            }
        },
        enumerable: true,
        configurable: true
    });
    Ng2Select.prototype.isEqual = function (itemOne, itemTwo) {
        return this.identifyBy ? itemOne[this.identifyBy] === itemTwo[this.identifyBy] :
            equal(itemOne, itemTwo);
    };
    Ng2Select.prototype.isSelected = function (item) {
        var _this = this;
        if (this.multiple) {
            return this.value.filter(function (value) { return _this.isEqual(item, value); }).length > 0;
        }
        else {
            return equal(this.value, item);
        }
    };
    Ng2Select.prototype.ngOnInit = function () {
        var _this = this;
        var state = this.dropdown.menu.state.dropdownState;
        state.onItemClicked.subscribe(function (item) {
            if (_this.multiple) {
                _this.toggle(item.value);
            }
            else {
                _this.value = _this.multiple ? _this.value : item.value;
            }
            _this.onChange.emit(_this.value);
        });
        this.dropdown.onShow.subscribe(function () {
            if (!_this.value) {
                return;
            }
            var index = _this.findIndexValue(_this.value);
            var item = _this.dropdown.menu.items.toArray()[index];
            state.select(item, false);
        });
    };
    return Ng2Select;
}(accessor_1.SelectAccessor));
__decorate([
    core_1.Input(),
    __metadata("design:type", Object)
], Ng2Select.prototype, "placeholder", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Object)
], Ng2Select.prototype, "options", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Object)
], Ng2Select.prototype, "displayBy", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Object)
], Ng2Select.prototype, "identifyBy", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Object)
], Ng2Select.prototype, "selectedDisplayBy", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Object)
], Ng2Select.prototype, "multiple", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], Ng2Select.prototype, "onChange", void 0);
__decorate([
    core_1.ViewChild(ng2_material_dropdown_1.Ng2Dropdown),
    __metadata("design:type", ng2_material_dropdown_1.Ng2Dropdown)
], Ng2Select.prototype, "dropdown", void 0);
Ng2Select = __decorate([
    core_1.Component({
        selector: 'ng2-select',
        providers: [CUSTOM_SELECT_VALUE_ACCESSOR],
        styleUrls: ['./style.scss'],
        templateUrl: './template.html'
    }),
    selectable_1.Selectable()
], Ng2Select);
exports.Ng2Select = Ng2Select;
//# sourceMappingURL=ng2-select.js.map